#include libdef
#include ssdef
#include lnmdef
#include psldef
#include descrip

#include <errno.h>
#include <fcntl.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/errno.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/ioctl.h>

#define VERBOSE 128


/* 
Change working directory to argv[3], 
process environment commands in argv[1] and 
run argv[4] with arguments argv[5] argv[6] ... argv[argc - 1]
*/

    int main(int argc, char *argv[]) {

      char buffer[101];
      int flags, verbose;

      char sysout[11] = "SYS$OUTPUT";
      $DESCRIPTOR (sysout_descr, sysout);
      
      char syserr[10] = "SYS$ERROR";
      $DESCRIPTOR (syserr_descr, syserr);

      int r0;

      FILE * err;
	
      r0 = lib$set_logical (&sysout_descr, &syserr_descr);
      if (!(r0&1)) {
	lib$signal (r0);
	exit (r0);
      }

      err = fopen ("SYS$ERROR", "w");

      if(argc < 5) {
         fprintf(err, " ----jGRASP wedge: Wrong number of arguments.\n");
         return 1;
      }
   
      if(sscanf(argv[2], "%d", &flags) != 1) {
         fprintf(err, " ----jGRASP wedge internal error: "
            "bad flags argument to wedge.\n");
         return 4;
      }
      verbose = (flags & VERBOSE) != 0;
   
      if(chdir(argv[3]) != 0) {
         fprintf(err, " ----jGRASP wedge: Unable to change working directory to "
            "\"%s\".\n", argv[3]);
         return 2;
      }   

      safeExecvp_(argv[4], argv + 4);	

      /* Execution failed */
      fprintf(err, " ----jGRASP wedge: could not execute  %s\n", argv[4]);
      fprintf(err, "         (%s must be available on your system to" 
              " use this function). \n", argv[4]);
      
      fclose (err);
    }
        
   
   static int safeExecvp_(const char *file, char *const argv[])
   {      
      while(execvp(file, argv) == -1 && errno == EINTR);
      return 1;      
   }
   
